<template>
    <q-page style="width: 100%; height: 100vh" class="row justify-center items-center">

        <q-stepper
            ref="stepper"
            v-model="step"
            color="primary"
            animated
            :vertical="!$q.screen.lg"
            :class="SteppedClass"
            class="col-lg-6 col-12">
            <q-step :name="1" title="Verify your email" icon="icofont-email" :style="StepStyle"
                    :done="step > 1">
                <VerifyEmail/>
            </q-step>

            <q-step :name="2" title="Setup Profile" icon="icofont-ui-user" :style="StepStyle"
                    :done="step > 2">
                <SetupProfile v-if="$coreAuth.user == null" ref="profile"/>
                <div v-if="$coreAuth.user != null" class="column items-center justify-center q-gutter-md"
                     style="height: 300px;">
                    <div class="text-h4 text-weight-light">Registration Completed</div>
                    <div class="text-subtitle1">Your username is
                        <span class="text-weight-bold">
                            <span class="text-primary">{{ NameString }}</span>
                            <span class="text-italic text-grey-6">#{{ NameCode }}</span>
                        </span>
                    </div>
                    <div class="text-body1">
                        Please share this with your colleagues to invite you into projects
                    </div>
                </div>
            </q-step>
            <q-step :name="3" title="Allow Notifications" icon="icofont-notification" :done="step > 3"
                    :disable="$q.platform.is.ios || !CanNotification" :style="StepStyle">
                <AskPushNotification/>
            </q-step>

            <q-step :name="4" title="Install as App" icon="add_comment" :style="StepStyle">
                <PWAPrompt/>
            </q-step>
            <template v-slot:navigation>
                <q-stepper-navigation class="row justify-end q-gutter-md">
                    <q-btn @click="Click"
                           :loading="loading"
                           :color="Valid ? 'primary' : 'grey-5'"
                           :disable="!Valid"
                           :label="Label"/>
                </q-stepper-navigation>
            </template>
        </q-stepper>
    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import VerifyEmail from "components/Registration/VerifyEmail.vue";
import SetupProfile from "components/Registration/SetupProfile.vue";
import AskPushNotification from "components/Registration/AskPushNotification.vue";
import PWAPrompt from "components/Registration/PWAPrompt.vue";

@Component({
    components: {PWAPrompt, AskPushNotification, SetupProfile, VerifyEmail}
})
export default class Register extends Vue {

    step = 1

    loading = false;

    async created() {
        await this.$auth.Authenticate();
        if (this.$auth.user?.email_verified) {
            this.step = 2;
        } else {
            this.step = 1;
        }
        const r = await this.$coreAuth.Registered();
        if (r.isOk() && r.unwrap()) {
            await this.$router.push('/')
        }

    }

    get StepStyle(): string {
        return this.$q.platform.is.mobile ? '' : 'min-height:400px;';
    }


    get NameString(): string {
        return this.$coreAuth.user?.principal?.username.split("#")[0] ?? ""
    }

    get NameCode(): string {
        return this.$coreAuth.user?.principal?.username.split("#")[1] ?? "0000"
    }


    get CanNotification() {
        return 'Notification' in window && !!Notification;
    }

    get SteppedClass(): string {
        return this.$q.platform.is.mobile ? 'full-height' : "";
    }

    get Label() {
        switch (this.step) {
            case 4:
                return "Finish";
            case 2:
                return this.$coreAuth.user == null ? "Setup" : "Next";
            default:
                return "Next";
        }
    }

    get Valid() {
        switch (this.step) {
            case 1:
                return this.$auth.user?.email_verified;
            case 2:
                return true;
            default:
                return true;
        }
    }

    async Click() {
        this.loading = true;
        if (this.step == 2 && this.$coreAuth.user == null) {
            await (this.$refs.profile as any).Submit();
        } else if (this.step == 4) {
            await this.$router.push("/")
        } else {
            (this.$refs.stepper as any).next()
        }
        this.loading = false;
    }

}
</script>
